c Copyright (c) 2013, Dr Renato Vacondio, Dr Benedict Rogers, Prof. Peter Stansby 
c and Prof. Paolo Mignosa
c 
c All rights reserved.
c 
c This file is part of SWE-SPHYSICS.
c 
c Redistribution and use in source and binary forms, with or without modification, 
c are permitted provided that the following conditions are met:
c 
c - Redistributions of source code must retain the above copyright notice, 
c  this list of conditions and the following disclaimer.
c - Redistributions in binary form must reproduce the above copyright notice, 
c  this list of conditions and the following disclaimer in the documentation 
c  and/or other materials provided with the distribution.
c
c THE "SWE-SPHYSICS" IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
c ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
c OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
c THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
c SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
c OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
c HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR 
c TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
c EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
      subroutine getdata
      use global_2D

      character supp_ini*4,name_ini*40

      integer i, iallo, ii, j, k, nplinkmax_coa, np_ob_y, i_openbc
      real area_min_coa, xp_ob_p, yp_ob_p

       open(11,file='indat')
   
       read(11,44) rho0
       write(*,*) 'rho0=',rho0, 'water density'
       read(11,44) viscos_val
       write(*,*) 'viscos_val=',viscos_val, 'artif viscosity'
       read(11,44) dw_min_fric
       write(*,*) 'dw_min_fric= ', dw_min_fric
       read(11,44) coef
       write(*,*) 'coef=', coef
       read(11,44) vlx
       write(*,*)  'vlx=',vlx
       read(11,44) vly
       write(*,*)  'vly=',vly
       read(11,43) np
       write(*,*)  'np=',np
       read(11,43) np_b
       write(*,*)  'np_b=',np_b
       read(11,43) npv
       write(*,*)  'npv=',npv
       read(11,43) i_openbc
       write(*,*) 'i_openbc=', i_openbc
       read(11,44) distmin
       write(*,*)  'distmin=',distmin    
       read(11,44) tol
       write(*,*)  'tol=',tol
       read(11,43) ivar_dt
       write(*,*)  'ivar_dt=',ivar_dt
       read(11,44) dt
       write(*,*)  'dt=',dt
       read(11,44) CFL
       write(*,*)  'CFL=',CFL
       read(11,44) tmax
       write(*,*)  'tmax=',tmax
       read(11,44) out
       write(*,*)  'out=',out
       read(11,44) trec_ini
       write(*,*)  'trec_ini=',trec_ini
       read(11,43) i_restartRun 
       write(*,*)  'i_restartRun=',i_restartRun 
       read(11,44) hsm_b_max
       write(*,*)  'hsm_b_max=',hsm_b_max
       read(11,43) n0
       write(*,*)  'n0=',n0
       read(11,43) idebug
       write(*,*)  'idebug=',idebug
       read(11,43) iMUSCL
       write(*,*)  'iMUSCL=',iMUSCL
       read(11,43) i_dw_iter
       write(*,*)  'i_dw_iter=',i_dw_iter
       read(11,43) i_max_iter
       write(*,*)  'i_max_iter=',i_max_iter

       !refining
       ! read(11,44) area_lim
       read(11,44) ref_p    
       write(*,*)  'ref_p =',ref_p  
       read(11,44) ref_h 
       write(*,*)  'ref_h =',ref_h  
       read(11,44) dw_min_ref 
       write(*,*)  'dw_min_ref=', dw_min_ref 
       read(11,44) xmin_ref
       write(*,*)  'xmin_ref=', xmin_ref
       read(11,44) ymin_ref
       write(*,*)  'ymin_ref=', ymin_ref
       read(11,44) dxx_ref
       write(*,*)  'dxx_ref=', dxx_ref
       read(11,44) dyy_ref
       write(*,*)  'dyy_ref=', dyy_ref
       read(11,43) ncx_ref
       write(*,*)  'ncx_ref=', ncx_ref
       read(11,43) ncy_ref
       write(*,*)  'ncy_ref=', ncy_ref
       !reading data to export on regular grid
       read(11,44) dx_grd
       write(*,*)  'dx_grd=', dx_grd
       read(11,44) dy_grd
       write(*,*)  'dy_grd=', dy_grd
       
       close(11)
      
43     format(i6)
44     format(f16.6)

! to be removed: no mirrored particles implemented
!      np_fixed=np

      one_over_2hsm_b=1/(2*hsm_b_max)
      dtmax=dt
      dt_vir=dt
      
      pi = 4.d0*datan(1.d0)
      twopi=2.*pi
      
      !kernel parameters
      alphad=15./(7.*pi)  
      const_ker(1)=(1./6.)*alphad
      const_ker(2)=(2./3.)*alphad   
    
       if (np .ge. npar ) then
         write(*,*) 'Number of particles exceeds npar in global_2D.f!'
         stop
       endif
       if (np .ge. npar ) then
         write(*,*) 'Number of particles exceeds npar in global_2D.f!'
         stop
       endif
       if (np_b .ge. npar ) then
         write(*,*) 'Number of bottom particles exceeds'
         write(*,*) 'npar in global_2D.f!: np_b= ', np_b, 'npar=', npar
         stop
       endif

C     Initial image to RUN
     
      if(i_restartRun.eq.1) then

         open(44,file='restart')
         read(44,100) itime,time,ngrab
         close(44)

100   format(i8,e16.8,i8)

         name_ini='ipart'
         write(*,*) name_ini
         
         write(supp_ini,'(i4.4)') ngrab
         name_ini='PART_'//supp_ini
         write(*,*) name_ini

       else
       
         itime = 0
         ngrab = 1
         grab_P = 0.0
         name_ini='ipart'

       endif
       
       print*,'i_restartRun ',i_restartRun 
       write(*,*)'Reading in ', name_ini

c     --- Load Particle Position Data ---  
       area_min=1.E18
       hmax=0
       open(13,file=name_ini)
       do i=1,np
           read(13,*) xp(i),yp(i),up(i),vp(i),dw(i),areap(i), h_var(i), 
     + iflag(i)
c           write(*,*) xp(i),yp(i),up(i),vp(i),dw(i),areap(i), h_var(i), 
c     + iflag(i)

          h_var0(i)=h_var(i)
          uo(i)=up(i) !inizialize velocity at n-1/2
          if ( hmax.lt.h_var(i) ) then
               hmax=h_var(i)
                 write(*,*) 'hmax=',hmax
          endif

           if (  areap(i) .lt. area_min )  then
                 area_min=areap(i)
                 write(*,*) 'area_min=',area_min, 'i= ', i
           endif
 
       enddo
       close(13)
                            
       nstart=1
       write(*,*)' All ',np,' initial points read successfully'
    
c     --- End Load Particle Position Data --- 
                
c     --- Load Virtual Particle Position Data ---

        open(16,file='ipartv')
        do i=1,npv
           read(16,*) xv(i), yv(i), vnxv(i), vnyv(i), dxv(i)
        enddo
        
c     --- END OF load Virtual Particle Position Data ---

c     --- Load bottom particle Position Data ---
       
       xmaxb=1.E-10
       xminb=1.E+10
       ymaxb=1.E-10
       yminb=1.E+10
       Vol_b_min=1.E18
       if (np_b.gt.0) then
          open(14,file='ibottom')
          do i=1,np_b
              read(14,*) xb(i), yb(i), hb(i), fr(i), hsm_b(i), 
     + Vol_b(i)
              if(xb(i).gt.xmaxb) xmaxb=xb(i)
              if(xb(i).lt.xminb) xminb=xb(i)
              if(yb(i).gt.ymaxb) ymaxb=yb(i)
              if(yb(i).lt.yminb) yminb=yb(i) 
              if( Vol_b_min.gt.Vol_b(i) ) Vol_b_min=Vol_b(i)
          enddo
          close(14)
       
          xmaxb = xmaxb + 0.1*hsm_b_max
          xminb = xminb - 0.1*hsm_b_max
          ymaxb = ymaxb + 0.1*hsm_b_max
          yminb = yminb - 0.1*hsm_b_max
       
          ncx_b = int( (xmaxb-xminb)/(2*hsm_b_max) ) + 1
          ncy_b = int( (ymaxb-yminb)/(2*hsm_b_max) ) + 1
          nct_b = ncx_b*ncy_b
  
! to be removed: better to dynamically allocate iboxb, ncb: introduce      
!          if(nct_b .gt. nct_max) then
!                print*
!                print*,'ERROR in getdata.f'
!                print*,'No. of cells for bottom particles exceeds 
!     +           nct_max in global_2D.f '
!                print*,'nct_b ',nct_b
!                print*,'nct_max ',nct_max
!                print*
!                stop
!          endif        
       endif

c     --- End load bottom particle Position Data -

c     --- area_lim data ---
        nct_ref=ncx_ref*ncy_ref
        allocate(area_lim(nct_ref), STAT=iallo)
        if (iallo .ne. 0) then
            STOP 'allocation error area_lim'
        endif
        allocate(area_lim_coa(nct_ref), STAT=iallo)
        if (iallo .ne. 0) then
            STOP 'allocation error area_lim_coa'
        endif        
        allocate(nc_coa(nct_ref), STAT=iallo)
        if (iallo .ne. 0) then
            STOP 'allocation error nc_coa'
        endif
        
        open(87,file='area_lim')
        read(87,*) area_lim(1), area_lim_coa(1)
        area_lim_min=area_lim(1)
        area_min_coa=area_lim_coa(1)
        write(*,*) 'area_min_coa=', area_min_coa 
        do i=2,nct_ref
           
           read(87,*) area_lim(i), area_lim_coa(i)
                      
           if (area_lim(i).lt.area_lim_min) then
              area_lim_min=area_lim(i)
           endif
           if (area_lim_coa(i).lt.area_min_coa) then
              area_min_coa=area_lim_coa(i)
              write(*,*) 'area_min_coa=', area_min_coa
           endif
           
        enddo
        close(87)
        
        nplinkmax_coa=n0*(int( (5.*dxx_ref)/sqrt(area_min_coa))+1 )**2
        nplinkmax_coa=min( nplinkmax_var,2000)
        write(*,*) 'nct_ref= ',nct_ref, 'nplinkmax_coa= ',nplinkmax_coa
        allocate(ibox_coa(nct_ref,nplinkmax_coa), STAT=iallo)
        if (iallo .ne. 0) then
            STOP 'allocation error for ibox_coa'
        endif
        
c     --- END OF area_lim data --
       
c ---  Load openbc data --- 
       if (i_openbc.eq.1) then

       open(15,file='open_bc')
       read(15,*)   nopen_bou !number of open boundary conditions
       
       k=0 !counter of open boundary particles

       allocate( iflagbc(nopen_bou), STAT=iallo )
       allocate( xpbc(nopen_bou), STAT=iallo )
       allocate( ypbc(nopen_bou), STAT=iallo )
       allocate( lbc(nopen_bou), STAT=iallo )
       allocate( verbc(nopen_bou,2), STAT=iallo )
       allocate( verybc(nopen_bou), STAT=iallo )
       allocate( dxobc(nopen_bou), STAT=iallo )
       allocate( ndata_obc(nopen_bou), STAT=iallo )

       allocate(time_obc(nopen_bou,1000), STAT=iallo)
       allocate(dwbc_time(nopen_bou,1000), STAT=iallo)
       allocate(upbc_time(nopen_bou,1000), STAT=iallo)
       !allocate(ndata_obc(nopen_bou), STAT=iallo)   !BDR - Why twice???
       allocate(dwbc(nopen_bou), STAT=iallo)
       allocate(upbc(nopen_bou), STAT=iallo)

       do i=1,nopen_bou !loop over different boundary conditions !1
       
             read(15,*)  iflagbc(i)
             read(15,*)  xpbc(i)
             read(15,*)  ypbc(i)
             read(15,*)  lbc(i)
             read(15,*)  verbc(i,1)
             read(15,*)  verbc(i,2)
             read(15,*)  verybc(i)
             read(15,*)  dxobc(i)
             read(15,*)  ndata_obc(i) !number of data points for the i-th open boundary condition
              
             if (ndata_obc(i).gt.1000) then 
                   write(*,*)  'increase allocation for ibc_time 
     + variables'
                   stop 
             endif
             
             do j=1,ndata_obc(i) !loop over time steps for i-th bc
               read(15,*) time_obc(i,j), dwbc_time(i,j), upbc_time(i,j)
             enddo !loop over time steps for i-th bc
             
             if (time_obc(i,ndata_obc(i)).lt.tmax) then
                 write(*,*) 'ERROR IN OPENBC variable data: max time of' 
     + ,'boundary n=', i,'is',time_obc(i,j),'< tmax=',tmax 
                 stop
             endif
             
             ! calculate np_ob_y: number of point for i open bc
             np_ob_y=int( lbc(i)/dxobc(i) )+1 
             dxobc(i)=lbc(i)/np_ob_y
             
             do ii=1,np_ob_y !2
             
                do j=1,2 !coordinates of open bc particles !3
             
                k=k+1
                ibc(k)=i !index of boundary
                
                !transformatio to the new local coordinate system 
                xp_ob_p=-(j-0.5)*dxobc(i)
                yp_ob_p=+(ii-0.5)*dxobc(i)*verybc(i)
                
                !back to the global coordinate system 
                xp_ob(k)=xpbc(i)+xp_ob_p*verbc(i,1)-yp_ob_p*verbc(i,2)
                yp_ob(k)=ypbc(i)+xp_ob_p*verbc(i,2)+yp_ob_p*verbc(i,1)
                pm_ob(k)=dxobc(i)*dxobc(i)*rho0*dwbc_time(i,1) !this is correct just for supercritical flows or for outflow bc
                h_var_ob(k)=dxobc(i)*coef*2
                
                iflag_ob(k)=iflagbc(i)
                h_var0_ob(k)=h_var_ob(k)/2. !< it is useflul just when a ob particle become fluid particle
                dw0_ob(k)=dwbc_time(i,1) 

                !write(*,*) 'open boundary particles', k, xp_ob(k), yp_ob(k), pm_ob(k), dw0_ob(k), h_var_ob(k), iflag_ob(k)
                
                !this is introuced for cases with totally dry bed
                if ( dxobc(i)*dxobc(i) .lt.area_min ) then
                   area_min=dxobc(i)*dxobc(i)
                endif
                
                if (hmax.lt.dxobc(i)*coef) then
                   hmax=dxobc(i)*coef
                endif
           
                enddo !3
                
             enddo !2
               
       enddo !loop over different boundary conditions !1
       
       close(15)

       np_ob=k

       else !no open boundaries

       nopen_bou=0
       np_ob=0

       endif
       
c ---  END OF Load openbc data --- 
             		 
c
c ,,,, viscosity term eta2
c
       one_over_2hmax=1./(2.*hmax)   
       eta  = 0.1*hmax
       eta2 = eta*eta

       !- Limits of domain -    
       xmax_container = vlx
       xmin_container = 0
       ymax_container = vly
       ymin_container = 0

       xlim_left=0
       xlim_right=vlx
       xmin=xlim_left-2*hmax
       xmax=xlim_right+2*hmax

       ylim_left=0
       ylim_right=vly
       ymin=ylim_left-2*hmax
       ymax=ylim_right+2*hmax


       write(*,*)'xmin_container, xmax_container = ',
     &            xmin_container,xmax_container
       write(*,*)'ymin_container, ymax_container = ',
     &            ymin_container,ymax_container
       print*
             
c      -- Add small border region to prevent error --
c      -- when calculating icell.. in divide       --
       xmax = xmax + 0.1*hmax
       xmin = xmin - 0.1*hmax
       ymax = ymax + 0.1*hmax   
       ymin = ymin - 0.1*hmax

       ! To place particles in a convenient place that leave the domain
       xtrash=2.*xmax
       ytrash=0.
       
       ncx = int( (xmax-xmin)*one_over_2hmax ) + 1
       ncy = int( (ymax-ymin)*one_over_2hmax ) + 1
 
       nct = ncx*ncy
       
       write(*,*)'xmin, xmax = ',xmin,xmax
       write(*,*)'ymin, ymax = ',ymin,ymax
       
       write(*,*)'ncx/y    = ',ncx,ncy
       write(*,*)'nct= ',nct
       
c-------------------------------------   
c  --- export data on regular grid ---
c-------------------------------------
      
       nplot_x=int(vlx/dx_grd)+1
       nplot_y=int(vly/dy_grd)+1

       dx_grd=vlx/nplot_x
       dy_grd=vly/nplot_y
       
       !just for debug
       write(*,*) 'dx_grd,dy_grd =',dx_grd,dy_grd
       write(*,*) 'nplot_x,nplot_y =',nplot_x,nplot_y
       
       !allocate
       allocate(dw_grd(nplot_x,nplot_y), STAT=iallo)
       if (iallo .ne. 0) then
           STOP 'dw_grd allocation error'
       endif 
       
       allocate(up_grd(nplot_x,nplot_y), STAT=iallo)
       if (iallo .ne. 0) then
           STOP 'up_grd allocation error'
       endif
       
       allocate(vp_grd(nplot_x,nplot_y), STAT=iallo)
       if (iallo .ne. 0) then
           STOP 'vp_grd allocation error'
       endif
   
       allocate(sum_grd(nplot_x,nplot_y), STAT=iallo)
       if (iallo .ne. 0) then
           STOP 'sum_grd allocation error'
       endif
       
       allocate(dx_fs_grd(nplot_x,nplot_y), STAT=iallo)
       if (iallo .ne. 0) then
           STOP 'dx_fs_grd allocation error'
       endif
       
       allocate(dy_fs_grd(nplot_x,nplot_y), STAT=iallo)
       if (iallo .ne. 0) then
           STOP 'dy_fs_grd allocation error'
       endif
       
       return
       end
       
c     ___________________
